package com.sa.ibiz.demo.demo.service.dto;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.ibizutil.domain.ParentData;
import com.sa.ibiz.demo.demo.domain.WFVersion;
import org.springframework.util.StringUtils;
import lombok.Data;
import java.util.Map;
import java.sql.Timestamp;
import com.sa.ibiz.demo.ibizutil.service.SearchFilterBase;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.sa.ibiz.demo.ibizutil.helper.DataGridCustomSearchHelper;
import com.alibaba.fastjson.JSONObject;
@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class WFVersionSearchFilter extends SearchFilterBase {

	private String query;
	private Page page;
	private QueryWrapper<WFVersion> selectCond;
	private JSONObject customsearchval;
	public WFVersionSearchFilter(){
		this.page =new Page<WFVersion>(1,Short.MAX_VALUE);
		this.selectCond=new QueryWrapper<WFVersion>();	
	}

	/**
	 * 设定自定义查询条件，在原有SQL基础上追加该SQL
	 */
	public void setCustomCond(String sql)
	{
		this.selectCond.apply(sql);
	}

	private String n_wfwfid_eq;

	public void setN_wfwfid_eq(String n_wfwfid_eq) {
        this.n_wfwfid_eq = n_wfwfid_eq;
        if(!StringUtils.isEmpty(this.n_wfwfid_eq)){
            this.selectCond.eq("wfwfid", n_wfwfid_eq);
        }
    }
	private String n_wfwfname_eq;

	public void setN_wfwfname_eq(String n_wfwfname_eq) {
        this.n_wfwfname_eq = n_wfwfname_eq;
        if(!StringUtils.isEmpty(this.n_wfwfname_eq)){
            this.selectCond.eq("wfwfname", n_wfwfname_eq);
        }
    }
	private String n_wfwfname_like;

	public void setN_wfwfname_like(String n_wfwfname_like) {
        this.n_wfwfname_like = n_wfwfname_like;
        if(!StringUtils.isEmpty(this.n_wfwfname_like)){
            this.selectCond.like("wfwfname", n_wfwfname_like);
        }
    }
	private String n_wfwfversionname_like;

	public void setN_wfwfversionname_like(String n_wfwfversionname_like) {
        this.n_wfwfversionname_like = n_wfwfversionname_like;
        if(!StringUtils.isEmpty(this.n_wfwfversionname_like)){
            this.selectCond.like("wfwfversionname", n_wfwfversionname_like);
        }
    }

	public void setSrfparentdata(Map<String, String> srfparentdata) {
		this.srfparentdata = srfparentdata;
		String strParentkey=this.getSrfparentdata().get("srfparentkey");
		if(this.srfparentdata.containsKey("srfparentmode")&& this.getSrfparentdata().get("srfparentmode").equals("DER1N_WFWFVERSION_WFWORKFLOW_WFWFID"))
			if(StringUtils.isEmpty(strParentkey)){
				this.setN_wfwfid_eq("NA");
			}
			else{
				this.setN_wfwfid_eq(strParentkey);
			}
	}

	/**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
			this.selectCond.or().like("wfwfversionname",query);
		 }
	}

	/**
	 * 自定义查询
	 * @param customsearchval
	 */
	public void setCustomsearchval(JSONObject customsearchval) {
		this.customsearchval = customsearchval;
		if(!StringUtils.isEmpty(customsearchval)){
			DataGridCustomSearchHelper customSearchHelper= DataGridCustomSearchHelper.getInstance();
			String customSql =customSearchHelper.parseCustomVal(customsearchval);
			this.selectCond.apply(customSql);
		}
	}

}